<template>
  <v-dialog v-model="dialog" persistent max-width="25%">
    <v-card>
      <v-card-title>
        <span v-text="title" />
      </v-card-title>
      <v-card-text>
        <v-container>
          <v-row>
            <v-col cols="12">
              <v-text-field label="Regional ID*" v-model="regional.id" :disabled="statusProgress" required :readonly="isEdit" />
            </v-col>
          </v-row>
          <v-row>
            <v-col cols="12">
              <v-text-field label="Regional Nama*" v-model="regional.nama" :disabled="statusProgress" required />
            </v-col>
          </v-row>
        </v-container>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue darken-1" text @click="doSaveOrUpdate" :disabled="statusProgress">Simpan</v-btn>
        <v-btn color="blue darken-1" text @click="doReset" :disabled="statusProgress">Reset</v-btn>
        <v-btn color="blue darken-1" text @click="doClose" :disabled="statusProgress">Close</v-btn>
      </v-card-actions>
    </v-card>
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-dialog>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import service from "../service/RegionalService";

export default {
  name: "RegionalForm",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      regional: {
        id: null,
        nama: null,
      },
      title: null,
      dialog: false,
      isEdit: false,
      statusProgress: false,
    }
  },
  methods: {
    doClose() {
      this.dialog = false
    },
    doAdd(title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.doReset()
    },
    doEdit(id, title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.retrieve(id)
    },
    doReset() {
      this.regional.id = null
      this.regional.nama = null
    },
    async doSaveOrUpdate() {
      if (!this.validation()) {
        return
      }
      let data = {
        id: this.regional.id,
        nama: this.regional.nama
      }
      this.statusProgress = true
      if (!this.isEdit) {
        await this.doSave(data)
      } else {
        await this.doUpdate(data.id, data)
      }
      this.statusProgress = false
    },
    doSave(data) {
      service.store(data)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              await this.$parent.doRefresh()
              this.doReset()
            }
            this.$refs.dlgMsg.doOpenMsg(res.data.message)
          })
          .catch(ex => {
            console.log(ex)
            this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
          })
    },
    doUpdate(id, data) {
      service.update(id, data)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              await this.$parent.doRefresh()
            }
            this.dialog = false
            this.$refs.dlgMsg.doOpenMsg(res.data.message)
          })
          .catch(ex => {
            console.log(ex)
            this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
          })
    },
    async retrieve(id) {
      this.statusProgress = true
      await service.get(id)
          .then(res => {
            this.regional = res.data.data
            console.log(this.regionals)
          })
      this.statusProgress = false
    },
    validation() {
      if (this.regional.id == null || this.regional.id === '') {
        this.$refs.dlgMsg.doOpenMsg('ID Harus Diisi')
        return false
      } else if (this.regional.nama == null || this.regional.nama === '') {
        this.$refs.dlgMsg.doOpenMsg('Nama Harus Diisi')
        return false
      }
      return true
    }
  }
}
</script>

<style scoped>

</style>